/*******************************************************************************
**3456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
**      10        20        30        40        50        60        70        80
**
** project:
**    "Bling it up - make it sexy!"
**
** file:
**    cairo-rendering.h
**
** author:
**    Mirco "MacSlow" Mueller <macslow@bangang.de>
**
** copyright (C) Mirco Mueller, february 2007, placed under the terms of the GPL
**
*******************************************************************************/

#ifndef _CAIRO_RENDERING_H
#define _CAIRO_RENDERING_H

#include <gtk/gtk.h>
#include <cairo.h>
#include <librsvg/rsvg.h>
#include <librsvg/rsvg-cairo.h>

typedef enum _Layer
{
	LAYER_SLIDER_GLOW = 0,
	LAYER_SLIDER_TEXT,
	LAYER_SLIDER_BUTTON,
	LAYER_HOUR_HAND,
	LAYER_HOUR_HAND_SHADOW,
	LAYER_MINUTE_HAND,
	LAYER_MINUTE_HAND_SHADOW,
	LAYER_SECOND_HAND,
	LAYER_SECOND_HAND_SHADOW,
	LAYER_ANALOG_CLOCK,
	LAYER_BACKGROUND_LOGO,
	LAYER_BACKGROUND_SLIDER,
	LAYER_BACKGROUND,
	LAYER_MAX_ELEMENTS
} Layer;

typedef enum _Surface
{
	SURFACE_GLOW = 0,
	SURFACE_TEXT,
	SURFACE_BUTTON,
	SURFACE_CLOCK,
	SURFACE_BACKGROUND_LOGO,
	SURFACE_BACKGROUND_SLIDER,
	SURFACE_BACKGROUND_FULL,
	SURFACE_BACKGROUND,
	SURFACE_MAX_ELEMENTS
} Surface;

typedef enum _Stage
{
	STAGE_START = 0,
	STAGE_RUNNING,
	STAGE_END,
	STAGE_MAX_ELEMENTS
} Stage;

cairo_surface_t*
update_surface (Surface		   whichSurface,
		gint		   iWindowWidth,
		gint		   iWindowHeight,
		RsvgHandle*	   pSvgHandle,
		RsvgDimensionData* pDimension);

void
update_surface_buffers (gint iWindowWidth,
			gint iWindowHeight);

void
draw_surface_with_clip (cairo_t* pContext,
			cairo_surface_t* pSurface,
			double fAlpha,
			double fOffsetX,
			double fOffsetY,
			double fClipX,
			double fClipY,
			double fClipWidth,
			double fClipHeight);

void
render (cairo_t* pCairoContext,
	gint	 iWindowWidth,
	gint	 iWindowHeight);

void
cleanup (void);

#endif /* _CAIRO_RENDERING_H */
